var VueHighlightJS = (function (hljs, Vue) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hljs__default = /*#__PURE__*/_interopDefaultLegacy(hljs);
    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    /**
      * vue-class-component v7.2.6
      * (c) 2015-present Evan You
      * @license MIT
      */

    function _typeof(obj) {
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function (obj) {
          return typeof obj;
        };
      } else {
        _typeof = function (obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value: value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }

      return obj;
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) {
        for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

        return arr2;
      }
    }

    function _iterableToArray(iter) {
      if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance");
    }

    // The rational behind the verbose Reflect-feature check below is the fact that there are polyfills
    // which add an implementation for Reflect.defineMetadata but not for Reflect.getOwnMetadataKeys.
    // Without this check consumers will encounter hard to track down runtime errors.
    function reflectionIsSupported() {
      return typeof Reflect !== 'undefined' && Reflect.defineMetadata && Reflect.getOwnMetadataKeys;
    }
    function copyReflectionMetadata(to, from) {
      forwardMetadata(to, from);
      Object.getOwnPropertyNames(from.prototype).forEach(function (key) {
        forwardMetadata(to.prototype, from.prototype, key);
      });
      Object.getOwnPropertyNames(from).forEach(function (key) {
        forwardMetadata(to, from, key);
      });
    }

    function forwardMetadata(to, from, propertyKey) {
      var metaKeys = propertyKey ? Reflect.getOwnMetadataKeys(from, propertyKey) : Reflect.getOwnMetadataKeys(from);
      metaKeys.forEach(function (metaKey) {
        var metadata = propertyKey ? Reflect.getOwnMetadata(metaKey, from, propertyKey) : Reflect.getOwnMetadata(metaKey, from);

        if (propertyKey) {
          Reflect.defineMetadata(metaKey, metadata, to, propertyKey);
        } else {
          Reflect.defineMetadata(metaKey, metadata, to);
        }
      });
    }

    var fakeArray = {
      __proto__: []
    };
    var hasProto = fakeArray instanceof Array;
    function createDecorator(factory) {
      return function (target, key, index) {
        var Ctor = typeof target === 'function' ? target : target.constructor;

        if (!Ctor.__decorators__) {
          Ctor.__decorators__ = [];
        }

        if (typeof index !== 'number') {
          index = undefined;
        }

        Ctor.__decorators__.push(function (options) {
          return factory(options, key, index);
        });
      };
    }
    function isPrimitive(value) {
      var type = _typeof(value);

      return value == null || type !== 'object' && type !== 'function';
    }

    function collectDataFromConstructor(vm, Component) {
      // override _init to prevent to init as Vue instance
      var originalInit = Component.prototype._init;

      Component.prototype._init = function () {
        var _this = this;

        // proxy to actual vm
        var keys = Object.getOwnPropertyNames(vm); // 2.2.0 compat (props are no longer exposed as self properties)

        if (vm.$options.props) {
          for (var key in vm.$options.props) {
            if (!vm.hasOwnProperty(key)) {
              keys.push(key);
            }
          }
        }

        keys.forEach(function (key) {
          Object.defineProperty(_this, key, {
            get: function get() {
              return vm[key];
            },
            set: function set(value) {
              vm[key] = value;
            },
            configurable: true
          });
        });
      }; // should be acquired class property values


      var data = new Component(); // restore original _init to avoid memory leak (#209)

      Component.prototype._init = originalInit; // create plain data object

      var plainData = {};
      Object.keys(data).forEach(function (key) {
        if (data[key] !== undefined) {
          plainData[key] = data[key];
        }
      });

      return plainData;
    }

    var $internalHooks = ['data', 'beforeCreate', 'created', 'beforeMount', 'mounted', 'beforeDestroy', 'destroyed', 'beforeUpdate', 'updated', 'activated', 'deactivated', 'render', 'errorCaptured', 'serverPrefetch' // 2.6
    ];
    function componentFactory(Component) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      options.name = options.name || Component._componentTag || Component.name; // prototype props.

      var proto = Component.prototype;
      Object.getOwnPropertyNames(proto).forEach(function (key) {
        if (key === 'constructor') {
          return;
        } // hooks


        if ($internalHooks.indexOf(key) > -1) {
          options[key] = proto[key];
          return;
        }

        var descriptor = Object.getOwnPropertyDescriptor(proto, key);

        if (descriptor.value !== void 0) {
          // methods
          if (typeof descriptor.value === 'function') {
            (options.methods || (options.methods = {}))[key] = descriptor.value;
          } else {
            // typescript decorated data
            (options.mixins || (options.mixins = [])).push({
              data: function data() {
                return _defineProperty({}, key, descriptor.value);
              }
            });
          }
        } else if (descriptor.get || descriptor.set) {
          // computed properties
          (options.computed || (options.computed = {}))[key] = {
            get: descriptor.get,
            set: descriptor.set
          };
        }
      });
      (options.mixins || (options.mixins = [])).push({
        data: function data() {
          return collectDataFromConstructor(this, Component);
        }
      }); // decorate options

      var decorators = Component.__decorators__;

      if (decorators) {
        decorators.forEach(function (fn) {
          return fn(options);
        });
        delete Component.__decorators__;
      } // find super


      var superProto = Object.getPrototypeOf(Component.prototype);
      var Super = superProto instanceof Vue__default['default'] ? superProto.constructor : Vue__default['default'];
      var Extended = Super.extend(options);
      forwardStaticMembers(Extended, Component, Super);

      if (reflectionIsSupported()) {
        copyReflectionMetadata(Extended, Component);
      }

      return Extended;
    }
    var shouldIgnore = {
      prototype: true,
      arguments: true,
      callee: true,
      caller: true
    };

    function forwardStaticMembers(Extended, Original, Super) {
      // We have to use getOwnPropertyNames since Babel registers methods as non-enumerable
      Object.getOwnPropertyNames(Original).forEach(function (key) {
        // Skip the properties that should not be overwritten
        if (shouldIgnore[key]) {
          return;
        } // Some browsers does not allow reconfigure built-in properties


        var extendedDescriptor = Object.getOwnPropertyDescriptor(Extended, key);

        if (extendedDescriptor && !extendedDescriptor.configurable) {
          return;
        }

        var descriptor = Object.getOwnPropertyDescriptor(Original, key); // If the user agent does not support `__proto__` or its family (IE <= 10),
        // the sub class properties may be inherited properties from the super class in TypeScript.
        // We need to exclude such properties to prevent to overwrite
        // the component options object which stored on the extended constructor (See #192).
        // If the value is a referenced value (object or function),
        // we can check equality of them and exclude it if they have the same reference.
        // If it is a primitive value, it will be forwarded for safety.

        if (!hasProto) {
          // Only `cid` is explicitly exluded from property forwarding
          // because we cannot detect whether it is a inherited property or not
          // on the no `__proto__` environment even though the property is reserved.
          if (key === 'cid') {
            return;
          }

          var superDescriptor = Object.getOwnPropertyDescriptor(Super, key);

          if (!isPrimitive(descriptor.value) && superDescriptor && superDescriptor.value === descriptor.value) {
            return;
          }
        } // Warn if the users manually declare reserved properties

        Object.defineProperty(Extended, key, descriptor);
      });
    }

    function Component(options) {
      if (typeof options === 'function') {
        return componentFactory(options);
      }

      return function (Component) {
        return componentFactory(Component, options);
      };
    }

    Component.registerHooks = function registerHooks(keys) {
      $internalHooks.push.apply($internalHooks, _toConsumableArray(keys));
    };

    var __spreadArrays = (undefined && undefined.__spreadArrays) || function () {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    /** @see {@link https://github.com/vuejs/vue-class-component/blob/master/src/reflect.ts} */
    var reflectMetadataIsSupported = typeof Reflect !== 'undefined' && typeof Reflect.getMetadata !== 'undefined';
    function applyMetadata(options, target, key) {
        if (reflectMetadataIsSupported) {
            if (!Array.isArray(options) &&
                typeof options !== 'function' &&
                !options.hasOwnProperty('type') &&
                typeof options.type === 'undefined') {
                var type = Reflect.getMetadata('design:type', target, key);
                if (type !== Object) {
                    options.type = type;
                }
            }
        }
    }

    /**
     * decorator of a prop
     * @param  options the options for the prop
     * @return PropertyDecorator | void
     */
    function Prop(options) {
        if (options === void 0) { options = {}; }
        return function (target, key) {
            applyMetadata(options, target, key);
            createDecorator(function (componentOptions, k) {
                (componentOptions.props || (componentOptions.props = {}))[k] = options;
            })(target, key);
        };
    }

    /**
     * Escape code.
     *
     * @export
     * @param {string} code Code.
     * @returns {string}
     */
    function escape(code) {
        if (typeof code === 'string') {
            return code
                .replace(/&/g, '&amp;')
                .replace(/"/g, '&quot;')
                .replace(/'/g, '&apos;')
                .replace(/</g, '&lt;')
                .replace(/>/g, '&gt;');
        }
        else {
            return code;
        }
    }

    /**
     * Deeply get concatenated text from slot.
     *
     * @export
     * @param {VNode[] | undefined} slot A slot. (The collection of VNode)
     * @returns {string}
     */
    function getSlotText(slot) {
        if (Array.isArray(slot)) {
            return slot
                .map(node => {
                if (Array.isArray(node.children) && node.children.length > 0) {
                    return getSlotText(node.children);
                }
                else {
                    return node.text;
                }
            })
                .join('');
        }
        else {
            return '';
        }
    }

    // Detect either spaces or tabs but not both to properly handle tabs for indentation and spaces for alignment
    const INDENT_REGEX = /^(?:( )+|\t+)/;

    function getMostUsed(indents) {
    	let result = 0;
    	let maxUsed = 0;
    	let maxWeight = 0;

    	for (const [key, [usedCount, weight]] of indents) {
    		if (usedCount > maxUsed || (usedCount === maxUsed && weight > maxWeight)) {
    			maxUsed = usedCount;
    			maxWeight = weight;
    			result = key;
    		}
    	}

    	return result;
    }

    var detectIndent = string => {
    	if (typeof string !== 'string') {
    		throw new TypeError('Expected a string');
    	}

    	// Remember the size of previous line's indentation
    	let previousSize = 0;
    	let previousIndentType;

    	// Indents key (ident type + size of the indents/unindents)
    	let key;

    	// Remember how many indents/unindents have occurred for a given size and how many lines follow a given indentation.
    	// The key is a concatenation of the indentation type (s = space and t = tab) and the size of the indents/unindents.
    	//
    	// indents = {
    	//    t3: [1, 0],
    	//    t4: [1, 5],
    	//    s5: [1, 0],
    	//   s12: [1, 0],
    	// }
    	const indents = new Map();

    	for (const line of string.split(/\n/g)) {
    		if (!line) {
    			// Ignore empty lines
    			continue;
    		}

    		let indent;
    		let indentType;
    		let weight;
    		let entry;
    		const matches = line.match(INDENT_REGEX);

    		if (matches === null) {
    			previousSize = 0;
    			previousIndentType = '';
    		} else {
    			indent = matches[0].length;

    			if (matches[1]) {
    				indentType = 's';
    			} else {
    				indentType = 't';
    			}

    			if (indentType !== previousIndentType) {
    				previousSize = 0;
    			}

    			previousIndentType = indentType;

    			weight = 0;

    			const indentDifference = indent - previousSize;
    			previousSize = indent;

    			// Previous line have same indent?
    			if (indentDifference === 0) {
    				weight++;
    				// We use the key from previous loop
    			} else {
    				key = indentType + String(indentDifference > 0 ? indentDifference : -indentDifference);
    			}

    			// Update the stats
    			entry = indents.get(key);

    			if (entry === undefined) {
    				entry = [1, 0]; // Init
    			} else {
    				entry = [++entry[0], entry[1] + weight];
    			}

    			indents.set(key, entry);
    		}
    	}

    	const result = getMostUsed(indents);

    	let amount = 0;
    	let type;
    	let indent = '';

    	if (result !== 0) {
    		amount = Number(result.slice(1));

    		if (result[0] === 's') {
    			type = 'space';
    			indent = ' '.repeat(amount);
    		} else {
    			type = 'tab';
    			indent = '\t'.repeat(amount);
    		}
    	}

    	return {
    		amount,
    		type,
    		indent
    	};
    };

    var minIndent = string => {
    	const match = string.match(/^[ \t]*(?=\S)/gm);

    	if (!match) {
    		return 0;
    	}

    	return match.reduce((r, a) => Math.min(r, a.length), Infinity);
    };

    var stripIndent = string => {
    	const indent = minIndent(string);

    	if (indent === 0) {
    		return string;
    	}

    	const regex = new RegExp(`^[ \\t]{${indent}}`, 'gm');

    	return string.replace(regex, '');
    };

    var indentString = (string, count = 1, options) => {
    	options = {
    		indent: ' ',
    		includeEmptyLines: false,
    		...options
    	};

    	if (typeof string !== 'string') {
    		throw new TypeError(
    			`Expected \`input\` to be a \`string\`, got \`${typeof string}\``
    		);
    	}

    	if (typeof count !== 'number') {
    		throw new TypeError(
    			`Expected \`count\` to be a \`number\`, got \`${typeof count}\``
    		);
    	}

    	if (typeof options.indent !== 'string') {
    		throw new TypeError(
    			`Expected \`options.indent\` to be a \`string\`, got \`${typeof options.indent}\``
    		);
    	}

    	if (count === 0) {
    		return string;
    	}

    	const regex = options.includeEmptyLines ? /^/gm : /^(?!\s*$)/gm;

    	return string.replace(regex, options.indent.repeat(count));
    };

    var redent = (string, count = 0, options) => indentString(stripIndent(string), count, options);

    /**
     * Indent code.
     *
     * @export
     * @param {string} code Code.
     * @returns {string}
     */
    function indentCode(code) {
        if (typeof code === 'string') {
            const indent = detectIndent(code).indent || '\t';
            code = redent(code, 0, {
                indent
            });
            return code.trim();
        }
        else {
            return code;
        }
    }

    const inlineStyles = {
        display: 'inline !important',
        'vertical-align': 'middle'
    };
    let HighlightCode = class HighlightCode extends Vue__default['default'] {
        get hasCode() {
            return typeof this.code === 'string' && this.code.length > 0;
        }
        render(h) {
            const { hasCode, inline, auto } = this;
            let lang = this.lang;
            let code = hasCode ? this.code : getSlotText(this.$slots.default); // If no `code`, get text from default slot.
            // Indent code if not use inline mode.
            if (!inline) {
                code = indentCode(code);
            }
            let highlightedCode;
            try {
                if (auto) {
                    ({
                        language: lang,
                        value: highlightedCode
                    } = hljs__default['default'].highlightAuto(code));
                }
                else {
                    highlightedCode = lang
                        ? hljs__default['default'].highlight(lang, code).value
                        : escape(code); // If no `lang`, just display plain code.
                }
            }
            catch (err) {
                highlightedCode = escape(code);
                console.error(err);
            }
            return h(!inline ? 'pre' : 'span', [
                h('code', {
                    class: ['hljs', ...(lang ? [lang] : [])],
                    style: inline ? inlineStyles : {},
                    domProps: {
                        innerHTML: highlightedCode
                    }
                })
            ]);
        }
    };
    __decorate([
        Prop(String)
    ], HighlightCode.prototype, "lang", void 0);
    __decorate([
        Prop({ type: Boolean, default: false })
    ], HighlightCode.prototype, "inline", void 0);
    __decorate([
        Prop(String)
    ], HighlightCode.prototype, "code", void 0);
    __decorate([
        Prop(Boolean)
    ], HighlightCode.prototype, "auto", void 0);
    HighlightCode = __decorate([
        Component({
            name: 'HighlightCode'
        })
    ], HighlightCode);
    var HighlightCode$1 = HighlightCode;

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    /**
     * @param {string} value
     * @returns {RegExp}
     * */
    /**
     * @param {RegExp | string } re
     * @returns {string}
     */
    function source(re) {
      if (!re) return null;
      if (typeof re === "string") return re;

      return re.source;
    }

    /**
     * @param {RegExp | string } re
     * @returns {string}
     */
    function lookahead(re) {
      return concat('(?=', re, ')');
    }

    /**
     * @param {RegExp | string } re
     * @returns {string}
     */
    function optional(re) {
      return concat('(', re, ')?');
    }

    /**
     * @param {...(RegExp | string) } args
     * @returns {string}
     */
    function concat(...args) {
      const joined = args.map((x) => source(x)).join("");
      return joined;
    }

    /**
     * Any of the passed expresssions may match
     *
     * Creates a huge this | this | that | that match
     * @param {(RegExp | string)[] } args
     * @returns {string}
     */
    function either(...args) {
      const joined = '(' + args.map((x) => source(x)).join("|") + ")";
      return joined;
    }

    /*
    Language: HTML, XML
    Website: https://www.w3.org/XML/
    Category: common
    Audit: 2020
    */

    /** @type LanguageFn */
    function xml(hljs) {
      // Element names can contain letters, digits, hyphens, underscores, and periods
      const TAG_NAME_RE = concat(/[A-Z_]/, optional(/[A-Z0-9_.-]+:/), /[A-Z0-9_.-]*/);
      const XML_IDENT_RE = /[A-Za-z0-9._:-]+/;
      const XML_ENTITIES = {
        className: 'symbol',
        begin: /&[a-z]+;|&#[0-9]+;|&#x[a-f0-9]+;/
      };
      const XML_META_KEYWORDS = {
        begin: /\s/,
        contains: [
          {
            className: 'meta-keyword',
            begin: /#?[a-z_][a-z1-9_-]+/,
            illegal: /\n/
          }
        ]
      };
      const XML_META_PAR_KEYWORDS = hljs.inherit(XML_META_KEYWORDS, {
        begin: /\(/,
        end: /\)/
      });
      const APOS_META_STRING_MODE = hljs.inherit(hljs.APOS_STRING_MODE, {
        className: 'meta-string'
      });
      const QUOTE_META_STRING_MODE = hljs.inherit(hljs.QUOTE_STRING_MODE, {
        className: 'meta-string'
      });
      const TAG_INTERNALS = {
        endsWithParent: true,
        illegal: /</,
        relevance: 0,
        contains: [
          {
            className: 'attr',
            begin: XML_IDENT_RE,
            relevance: 0
          },
          {
            begin: /=\s*/,
            relevance: 0,
            contains: [
              {
                className: 'string',
                endsParent: true,
                variants: [
                  {
                    begin: /"/,
                    end: /"/,
                    contains: [ XML_ENTITIES ]
                  },
                  {
                    begin: /'/,
                    end: /'/,
                    contains: [ XML_ENTITIES ]
                  },
                  {
                    begin: /[^\s"'=<>`]+/
                  }
                ]
              }
            ]
          }
        ]
      };
      return {
        name: 'HTML, XML',
        aliases: [
          'html',
          'xhtml',
          'rss',
          'atom',
          'xjb',
          'xsd',
          'xsl',
          'plist',
          'wsf',
          'svg'
        ],
        case_insensitive: true,
        contains: [
          {
            className: 'meta',
            begin: /<![a-z]/,
            end: />/,
            relevance: 10,
            contains: [
              XML_META_KEYWORDS,
              QUOTE_META_STRING_MODE,
              APOS_META_STRING_MODE,
              XML_META_PAR_KEYWORDS,
              {
                begin: /\[/,
                end: /\]/,
                contains: [
                  {
                    className: 'meta',
                    begin: /<![a-z]/,
                    end: />/,
                    contains: [
                      XML_META_KEYWORDS,
                      XML_META_PAR_KEYWORDS,
                      QUOTE_META_STRING_MODE,
                      APOS_META_STRING_MODE
                    ]
                  }
                ]
              }
            ]
          },
          hljs.COMMENT(
            /<!--/,
            /-->/,
            {
              relevance: 10
            }
          ),
          {
            begin: /<!\[CDATA\[/,
            end: /\]\]>/,
            relevance: 10
          },
          XML_ENTITIES,
          {
            className: 'meta',
            begin: /<\?xml/,
            end: /\?>/,
            relevance: 10
          },
          {
            className: 'tag',
            /*
            The lookahead pattern (?=...) ensures that 'begin' only matches
            '<style' as a single word, followed by a whitespace or an
            ending braket. The '$' is needed for the lexeme to be recognized
            by hljs.subMode() that tests lexemes outside the stream.
            */
            begin: /<style(?=\s|>)/,
            end: />/,
            keywords: {
              name: 'style'
            },
            contains: [ TAG_INTERNALS ],
            starts: {
              end: /<\/style>/,
              returnEnd: true,
              subLanguage: [
                'css',
                'xml'
              ]
            }
          },
          {
            className: 'tag',
            // See the comment in the <style tag about the lookahead pattern
            begin: /<script(?=\s|>)/,
            end: />/,
            keywords: {
              name: 'script'
            },
            contains: [ TAG_INTERNALS ],
            starts: {
              end: /<\/script>/,
              returnEnd: true,
              subLanguage: [
                'javascript',
                'handlebars',
                'xml'
              ]
            }
          },
          // we need this for now for jSX
          {
            className: 'tag',
            begin: /<>|<\/>/
          },
          // open tag
          {
            className: 'tag',
            begin: concat(
              /</,
              lookahead(concat(
                TAG_NAME_RE,
                // <tag/>
                // <tag>
                // <tag ...
                either(/\/>/, />/, /\s/)
              ))
            ),
            end: /\/?>/,
            contains: [
              {
                className: 'name',
                begin: TAG_NAME_RE,
                relevance: 0,
                starts: TAG_INTERNALS
              }
            ]
          },
          // close tag
          {
            className: 'tag',
            begin: concat(
              /<\//,
              lookahead(concat(
                TAG_NAME_RE, />/
              ))
            ),
            contains: [
              {
                className: 'name',
                begin: TAG_NAME_RE,
                relevance: 0
              },
              {
                begin: />/,
                relevance: 0
              }
            ]
          }
        ]
      };
    }

    var xml_1 = xml;

    /* eslint-disable @typescript-eslint/explicit-module-boundary-types */
    /* eslint-disable @typescript-eslint/no-explicit-any */
    /* eslint-disable @typescript-eslint/no-unsafe-call */
    /* eslint-disable @typescript-eslint/no-unsafe-member-access */
    var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };
    const core_1 = __importDefault(hljs__default['default']);
    const xml_1$1 = __importDefault(xml_1);
    if (!core_1.default.getLanguage('xml')) {
        core_1.default.registerLanguage('xml', xml_1$1.default);
    }
    function vue(hljs) {
        const SCRIPT_CLOSE_REGEX = /<\/script>/;
        const STYLE_CLOSE_REGEX = /<\/style>/;
        const generateScriptOpenRegEx = (lang) => {
            // Match default script.
            const DEFAULT_SCRIPT_REGEX = /<script>/;
            if (!lang) {
                return DEFAULT_SCRIPT_REGEX;
            }
            // Match script with lang.
            const scriptRegEx = new RegExp(`<script\\s+lang=['"]${lang}['"]>`);
            return scriptRegEx;
        };
        const generateStyleOpenRegEx = (lang) => {
            // Match default style with `scoped` support.
            const DEFAULT_STYLE_REGEX = /<style(\s+scoped)?>/;
            if (!lang) {
                return DEFAULT_STYLE_REGEX;
            }
            // Match style with lang with `scoped` support.
            const styleRegEx = new RegExp(`<style\\s+lang=['"]${lang}['"](\\s+scoped)?>`);
            return styleRegEx;
        };
        /*
         * Language mapping.
         * Key is Vue language id.
         * Value is Highlight.js language id.
         */
        const scriptLanguages = {
            '': 'javascript',
            ts: 'typescript'
        };
        const styleLanguages = {
            '': 'css',
            scss: 'scss',
            less: 'less',
            stylus: 'stylus'
        };
        // All sub-language parts
        const subLangParts = [
            ...Object.keys(scriptLanguages).map(vueLang => ({
                begin: generateScriptOpenRegEx(vueLang),
                end: SCRIPT_CLOSE_REGEX,
                subLanguage: scriptLanguages[vueLang],
                excludeBegin: true,
                excludeEnd: true
            })),
            ...Object.keys(styleLanguages).map(vueLang => ({
                begin: generateStyleOpenRegEx(vueLang),
                end: STYLE_CLOSE_REGEX,
                subLanguage: styleLanguages[vueLang],
                excludeBegin: true,
                excludeEnd: true
            }))
        ];
        return {
            name: 'Vue',
            subLanguage: 'xml',
            contains: [
                hljs.COMMENT(/<!--/, /-->/, {
                    relevance: 10
                }),
                ...subLangParts
            ]
        };
    }
    var vue_1 = vue;

    /**
     * Install Vue Highlight.js as plugin.
     *
     * @param {typeof Vue} vue Vue
     * @param {Options} [options={ languages: {} }] Options
     */
    const install = (vue, options = { languages: {} }) => {
        // Prevent error in Vue 3
        if (!vue.component) {
            return;
        }
        {
            window.hljs.registerLanguage('vue', vue_1);
        }
        vue.component('HighlightCode', HighlightCode$1);
    };
    if (typeof window !== 'undefined' && window.Vue) {
        install(window.Vue);
    }
    var index = {
        install
    };

    return index;

}(hljs, Vue));
//# sourceMappingURL=vue-highlight.web.js.map
